/******************************************************************************
 *
 * Project:  MapServer
 * Purpose:  Implements fast byt swapping for Endian conversion.
 * Author:   Donald Power
 *
 ******************************************************************************
 *
 ****************************************************************************/

#include <stdio.h>

#define SWAP_TWO_BYTES(data) \
( ((data >> 8) & 0x00FF) | ((data << 8) & 0xFF00) )

#define SWAP_FOUR_BYTES(data) \
( ((data >> 24) & 0x000000FF) | ((data >> 8) & 0x0000FF00) | \
((data << 8) & 0x00FF0000) | ((data << 24) & 0xFF000000) )


#define SWAP_EIGHT_BYTES(data) \
( ((data >> 56) & 0x00000000000000FF) | ((data >> 40) & 0x000000000000FF00) | \
((data >> 24) & 0x0000000000FF0000) | ((data >> 8) & 0x00000000FF000000) | \
((data << 8) & 0x000000FF00000000) | ((data << 24) & 0x0000FF0000000000) | \
((data << 40) & 0x00FF000000000000) | ((data << 56) & 0xFF00000000000000) )
